<?php
 
/**
 * @category	Module
 * @package		JomSocial
 * @subpackage	Users
 * @copyright (C) 2008 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 */

defined('_JEXEC') or die('Restricted access');

//require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
//require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'helpers' . DS . 'string.php' );


	function getConfig()
	{
        $db	=& JFactory::getDBO();
		$query = ' SELECT * ' . ' FROM #__chat_config ';
		$db->setQuery( $query );

		return $db->loadObject();
	}
	function getStatus()
	{
		$opts = array(
					'http'=>array(
							'timeout'=>2,
						)
				);
		$context = stream_context_create($opts); 
		
        $cfg = getConfig();
        $data = @file_get_contents("status.js");
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json)
	    {
	        $server =  $cfg->server;
	        switch ($server)
	        {
	            case 0:
	        	    $status_js = $cfg->api_url . "online.js";
	        	    if($rs = @file_get_contents($status_js, false, $context))
	        	    {
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 1:
	        	    $status_js = $cfg->api_url . "online.js?group=" . $cfg->group;
	        	    if($rs = @file_get_contents($status_js))
	        	    {
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 2:
	        		if ($cfg->room == '')
					{
						$cfg->room = $_SERVER['HTTP_HOST'];
					}
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $cfg->room;
	        	    if($rs = @file_get_contents($status_js))
	        	    {
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];
	        	        $status['rn'] = '';
	        	        $status['cn'] = '';
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			@file_put_contents("status.js",(time() + 120) . $status_json);
	    }
		return json_decode($status_json,true);
	}
	
	function getRooms()
	{
				$opts = array(
					'http'=>array(
							'timeout'=>2,
						)
				);
		$context = stream_context_create($opts); 
        $cfg = getConfig();
        $data = @file_get_contents("rooms.js");
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json)
	    {
	    	$server =  $cfg->server;
	        switch ($server)
	        {
	            case 0:
	        	    $room_js = $cfg->api_url . "rooms.js";
	        	    break;
	            case 1:
	        	    $room_js = $cfg->api_url . "rooms.js?group=" . $cfg->group;
	        	    break;
	            case 2:
	            	break;
	        }
	        if($rs = @file_get_contents($room_js, false, $context))
	        {
	        	$rooms_json = substr($rs,10,-1);
	        }
	        @file_put_contents("rooms.js",(time() + 120) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
	}
	
	
	function getUsers()
	{
				$opts = array(
					'http'=>array(
							'timeout'=>2,
						)
				);
		$context = stream_context_create($opts); 
        $cfg = getConfig();
		$data =  @file_get_contents("users.js");
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json)
	    {
	    	$server =  $cfg->server;
	        switch ($server)
	        {
	            case 0:
	                $rooms = getRooms();
	                if ($rooms == null)
	                {
	                	return null;
	                }
	                $users = array();
	                foreach ($rooms as $room)
	                {
	                    $user_js = $cfg->api_url . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = @file_get_contents($user_js, false, $context))
	                    {
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case 1:
	        	    $user_js = $cfg->api_url . "roomonlineusers.js?group=" . $cfg->group;
	        	    if($rs = @file_get_contents($user_js, false, $context))
	        	    {
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case 2:
	        		$users = array();
	        	    if ($cfg->room == '')
					{
						$cfg->room = $_SERVER['HTTP_HOST'];
					}	        		
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $cfg->room;
	        	    if($rs = @file_get_contents($user_js, false, $context))
	    	        {
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user)
	    	            {
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        @file_put_contents("users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
	}

