<?php 

defined('_JEXEC') or die('Restricted access');
jimport ( 'joomla.application.component.view' );

class CommunityViewChat extends CommunityView
{
	public function profile($tpl = null)
	{
		$document =& JFactory::getDocument();
		$document->setTitle('123 Flash Chat');

		$modle =& CFactory::getModel('chat');
		$cfg = $modle->getData();
		
		$chaturl = $this->getClientUrl($cfg);
		
		if ($cfg->server!=2 && $cfg->full_screen==1 && stristr($_SERVER['PHP_SELF'], 'index.php') == false)
		{
			$width = '100%';
			$height = '100%';
		}
		else
		{
			$width = $cfg->client_width . 'px';
			$height = $cfg->client_height . 'px';
		}
		
		$this->assign('width', $width);
        	$this->assign('height', $height);
		$this->assign('chaturl', $chaturl);
		$this->assign('server', $cfg->server);
		$this->assign('client', $cfg->client);
		$this->display($tpl);
	}

	public function getClientUrl($cfg)
	{
		$my	= CFactory::getUser();
		switch($cfg->server)
		{
			case 0:
				if ($cfg->server_host == '127.0.0.1' || $cfg->server_host == 'localhost')
				{
					$server_host = $_SERVER['HTTP_HOST'];
				}
				else
				{
					$server_host = $cfg->server_host;
				}
				if ($cfg->client_location != '')
				{
					$temp = $cfg->client_location;
				}
				else
				{
					$temp = 'http://' . $server_host . '/';
				}

				$clientname = $cfg->client ? (($cfg->client == 1) ? 'htmlchat/123flashchat.html' : 'avatarchat.swf') : '123flashchat.swf';
				$url =  $temp . $clientname . "?init_host=" . $cfg->server_host . "&init_port=" . $cfg->server_port . "&init_lang=" . $cfg->client_lang;
				$url .= $cfg->client ? "" : ("&init_skin=" . $cfg->client_skin);
				$url .= ($cfg->server == 1) ? ("&init_group=" . $cfg->group) : "";
		        if(!empty($my->username) && $my->_userid != 0)
		        {
            		$url .= (strpos($url,"?"))?"&init_user=".$my->username:"?init_user=".$my->username;
        		}
        		if(!empty($my->password) && $my->_userid != 0)
        		{
            			$url .= (strpos($url,"?"))?"&init_password=".$my->password:"?init_password=".$my->password;
        		}
				return $url;
				break;
				
			case 1:
				$server_port = 35555;
				$server_host = parse_url($cfg->client_location, PHP_URL_HOST);
				if ($urlinfo = $this->getHostParameters($cfg->client_location))
				{
					parse_str($urlinfo['query']);
					$server_host = $init_host;
					$server_port = $init_port;
				}
				
				$content = @file_get_contents($cfg->client_location);
				$clientname = $cfg->client ? (($cfg->client == 1) ? 'htmlchat/123flashchat.html' : 'avatarchat.swf') : '123flashchat.swf';
				$url = $cfg->client_location . $clientname . "?init_host=" . $server_host . "&init_port=" . $server_port . "&init_lang=" . $cfg->client_lang;
				$url .= $cfg->client ? "" : ("&init_skin=" . $cfg->client_skin);
				$url .= ($cfg->server == 1) ? ("&init_group=" . $cfg->group) : "";
				if(!empty($my->username) && $my->_userid != 0)
		        {
            		$url .= (strpos($url,"?"))?"&init_user=".$my->username:"?init_user=".$my->username;
        		}
        		if(!empty($my->password) && $my->_userid != 0)
        		{
            		$url .= (strpos($url,"?"))?"&init_password=".$my->password:"?init_password=".$my->password;
        		}
				return $url;
				break;
				
			case 2:
				if ($cfg->room == '')
				{
					$cfg->room = $_SERVER['HTTP_HOST'];
				}
				$url = "http://free.123flashchat.com/js.php?room=" . $cfg->room . "&skin="  . $cfg->client_skin . "&lang="  . $cfg->client_lang;
				if(!empty($my->username) && $my->_userid != 0)
		        {
            		$url .= (strpos($url,"?"))?"&user=".$my->username:"?user=".$my->username;
        		}
				return $url;
				break;
		}
	}
	
	function getHostParameters($client_location)
	{
		$content = @file_get_contents($client_location);
		if(!empty($content))
		{
			$pattern = '|var urlValue="(.*)"|U';
			preg_match($pattern, $content, $matches);
			if(!empty($matches[1]))
			{
				$url = $matches[1];
				$urlinfo = parse_url($url);
				return $urlinfo;
			}
			else
			{
				$pattern = '|PARAM NAME=movie VALUE="(.*)"|U';
				preg_match($pattern, $content, $matches);
				if(!empty($matches[1]))
				{
					$url = $matches[1];
					$urlinfo = parse_url($url);
					return $urlinfo;
				}
			}
			return false;
		}
	}
}

?>