<?php
/**
 * @package Module 123 Flash Chat for Joomla! 1.5
 * @version $Id: chat.php  2010-06-17$
 * @author Daniel
 * @copyright (C) 2010 - TOPCMM SOFTWARE
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Content Component Controller
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class ChatControllerSettings extends JController
{
	/**
	 * Method to show an article as the main page display
	 *
	 * @access	public
	 * @since	1.5
	 */
	function display()
	{
		parent::display();
	}

	function save()
	{
		$model = $this->getModel('settings');
		if ($model->store($post)) {
			$msg = "The Chat Configuration details have been updated.";
		}
		else
		{
			$msg = $model->getError();
		}
		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_chat&view=settings';
		$this->setRedirect($link, $msg);
	} 
}
?>
