<?php
/**
 * @version		$Id: banner.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
 * @subpackage	Banners
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @package		Joomla
 * @subpackage	Banners
 */
class TableSettings extends JTable
{
	/** @var int */
	var $id				    = null;
	/** @var int */
	var $server				= null;
	/** @var string */
	var $server_host		= '';
	/** @var int */
	var $server_port		= 0;
	/** @var int */
	var $http_port			= 0;
	/** @var string */
	var $client_location	= '';
	/** @var string */
	var $api_url			= '';
	/** @var string */
	var $group				= '';
	/** @var string */
	var $room			    = '';
	/** @var int */
	var $client			    = 0;
	
	var $present_mode       = 1;
	
	var $full_screen        = 0;
	
	var $chat_status        = 1;
	
	var $room_list          = 1;
	
	var $user_list          = 1;
	
	/** @var int */
	var $client_width		= 0;
	/** @var int */
	var $client_height		= 0;
	/** @var string */
	var $client_lang		= '';
	/** @var string */
	var $client_skin	    = '';

	function __construct( &$_db )
	{
		parent::__construct( '#__chat_config', 'id', $_db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{
		return true;
	}
}
?>
