<?php 
/**
 * Admin Default Template for Blue Hour Calculator
 * 
 * @package     prt.com_prt
 * @subpackage  Components
 * @link        http://www.winkelewski.de
 * @license		GNU/GPL, some parts of this based on JS code by  Arnold Barmettler, www.astronomie.info / www.CalSky.com
 * @created     01.04.2010
 *
 *              based on algorithms by Peter Duffett-Smith's great and easy book 'Practical Astronomy with your Calculator'.
 */

defined('_JEXEC') or die('Restricted access'); 

  $cfg = $this->config;
  $app =& JFactory::getApplication();
  $sef_suffix = $app->getCfg('sef_suffix');
?>

<script type="text/javascript">

function showHide(id, sh)
{
	var e = document.getElementById(id);
	e.style.display = (sh == 1) ? '' : 'none';
}

function onclick_server_mode(id)
{
	if (id == 0)
	{
		if (document.getElementById("server_local").value == 0)
		{
			showHide('chat_port',0);
			showHide('chat_host',0);
			showHide('http_port',0);
			showHide('s_download',0);
		}
		else
		{
			showHide('chat_port',1);
			showHide('chat_host',1);
			showHide('http_port',1);
			showHide('s_download',1);
		}
		showHide('login_chat',1);
		showHide('client_location',1);
		showHide('room_name',0);
		if (document.getElementById('c_status_0').checked)
		{
			document.getElementById('room_list').style.display = '';
			document.getElementById('user_list').style.display = '';
		}
		else
		{
			document.getElementById('room_list').style.display = 'none';
			document.getElementById('user_list').style.display = 'none';
		}
		document.getElementById('client_mode').style.display = '';
		if (document.getElementById('c_mode_0').checked)
		{
			onclick_client_mode(0);
			document.getElementById('skin').style.display = '';
		}
		else if (document.getElementById('c_mode_1').checked)
		{
			onclick_client_mode(1);	
			document.getElementById('skin').style.display = 'none';		
		}
		else
		{
			onclick_client_mode(2);
			document.getElementById('skin').style.display = 'none';
		}
		if (document.getElementById('p_mode_0').checked || <?php echo $sef_suffix ?> == 1)
		{
			document.getElementById('c_size_0').checked = 'checked';
			document.getElementById('f_screen').style.display = 'none';
		}
		else
		{
			document.getElementById('f_screen').style.display = '';
		}
	}
	else if (id == 1)
	{
		showHide('chat_port',0);
		showHide('chat_host',0);
		showHide('http_port',0);
		showHide('login_chat',1);
		showHide('client_location',1);
		showHide('room_name',0);
		showHide('s_download',0);
		if (document.getElementById('c_status_0').checked)
		{
			document.getElementById('room_list').style.display = '';
			document.getElementById('user_list').style.display = '';
		}
		else
		{
			document.getElementById('room_list').style.display = 'none';
			document.getElementById('user_list').style.display = 'none';
		}
		document.getElementById('client_mode').style.display = '';
		if (document.getElementById('c_mode_0').checked)
		{
			document.getElementById('skin').style.display = '';
		}
		else if (document.getElementById('c_mode_1').checked)
		{
			document.getElementById('skin').style.display = 'none';			
		}
	
		else
		{
			document.getElementById('skin').style.display = 'none';
		}

		
		if (document.getElementById('p_mode_0').checked || <?php echo $sef_suffix ?> == 1)
		{
			document.getElementById('c_size_0').checked = 'checked';
			document.getElementById('f_screen').style.display = 'none';
		}
		else
		{
			document.getElementById('f_screen').style.display = '';
		}
	}
	else
	{
		showHide('s_download',0);
		showHide('chat_port',0);
		showHide('chat_host',0);
		showHide('http_port',0);
		showHide('client_location',0);
		showHide('room_name',1);
		showHide('login_chat',0);
		document.getElementById('room_list').style.display = 'none';
		if (document.getElementById('c_status_0').checked)
		{
			document.getElementById('user_list').style.display = '';
		}
		else
		{
			document.getElementById('user_list').style.display = 'none';
		}
		document.getElementById('client_mode').style.display = 'none';

		document.getElementById('c_size_0').checked = 'checked';
		
		document.getElementById('f_screen').style.display = 'none';

		document.getElementById('skin').style.display = '';
	}
}

function onclick_chat_status(id)
{
	if (id == 1)
	{
		if (document.getElementById('s_mode_2').checked)
		{
			document.getElementById('room_list').style.display = 'none';
		}
		else
		{
			document.getElementById('room_list').style.display = '';
		}
		document.getElementById('user_list').style.display = '';
	}
	else
	{
		document.getElementById('room_list').style.display = 'none';
		document.getElementById('user_list').style.display = 'none';
	}
}

function onclick_client_mode(id)
{
	if (id == 0)
	{
	    document.getElementById('skin').style.display= '';
	}
	else if (id ==1)
	{
	    document.getElementById('skin').style.display= 'none';
	}
	else
	{
	    document.getElementById('skin').style.display= 'none';
	}
}

function onclick_present_mode(id)
{
	if (id == 0)
	{
		document.getElementById('c_size_0').checked = 'checked';
		document.getElementById('f_screen').style.display = 'none';
	}
	else
	{
		if (document.getElementById('s_mode_2').checked  || <?php echo $sef_suffix ?> == 1)
		{
			document.getElementById('f_screen').style.display = 'none';
		}
		else
		{
			document.getElementById('f_screen').style.display = '';
		}
	}
}
</script>

<form action="index.php" method="post" name="adminForm" id="adminForm">
<div class="col100" >
	<fieldset class="adminform">
		<legend>Basic Settings</legend>
		<table class="admintable" cellspacing="1">
		<tr>
			<td  class="key"><span class="editlinktip hasTip" title="Chat Server Mode::3 options for you to choose.">Chat Server Mode</span></td>
			<td>
				 <input type="radio" name="server" id="s_mode_0" value="0" onclick="onclick_server_mode(0)" <?php if($cfg->server == 0){ echo 'checked="checked"';} ?>>Chat Server Host By Your Own
			<br/><input type="radio" name="server" id="s_mode_1" value="1" onclick="onclick_server_mode(1)" <?php if($cfg->server == 1){ echo 'checked="checked"';} ?>>Chat Server Host By 123 Flash Chat
			<br/><input type="radio" name="server" id="s_mode_2" value="2" onclick="onclick_server_mode(2)" <?php if($cfg->server == 2){ echo 'checked="checked"';} ?>>Chat Server Host By 123 Flash Chat For Free
			</td>
		</tr>

		<tr id="s_download" <?php if ($cfg->server !=0 || $this->valid == 0) {echo 'style="display: none"';}?>>
			<td class="key">
				<b>NOTE</b>
			</td>
			<td style="width:500px">
				<span style="color:#ff0000"> Please install 123FlashChat Server first before enable this Mod.</span>
				<a href= <?php $fc_download_url = 'http://www.123flashchat.com/download-now.html?p=123flashchat.' . ((PATH_SEPARATOR==':') ? (stristr(PHP_OS, 'darwin') ?  'dmg' : 'sh') : 'exe'); echo $fc_download_url; ?> target="_blank">Free Download</a>
			</td>
		</tr>

		<tr id='login_chat' <?php if ($cfg->server == 2) {echo 'style="display: none"';}?>>
			<td class="key"> 
				<b>Integration URL</b>
			</td>
			<td  style="width:500px">
				To integrate users for auto-login to chat, please open the Chat Admin Panel, 
				then System Settings > Integration Panel, set authentication URL to:
				<span style="color:#ff0000">http://&lt;Your Joomla root URL&gt;/index.php?option=com_chat&view=login&username=%username%&password=%password%</span>
			</td>
		</tr>

		<tr id="chat_host" <?php if(!$this->valid || $cfg->server){echo 'style="display:none"';}?>>
			<td class="key"><span class="editlinktip hasTip" title="Chat Server Host::Chat Server Host">Chat Server Host</span></td>
			<td>
				<input name="server_host" size="50" value=<?php echo $cfg->server_host; ?>>
			</td>
		</tr>
		<tr id="chat_port" <?php if(!$this->valid || $cfg->server){echo 'style="display:none"';}?>>
			<td class="key"><span class="editlinktip hasTip" title="Chat Server Port::Chat Server Port">Chat Server Port</span></td>
			<td>
				<input name="server_port" size="50" value=<?php echo $cfg->server_port; ?>>
			</td>
		</tr>
		<tr id="http_port" <?php if(!$this->valid || $cfg->server){echo 'style="display:none"';}?>>
			<td class="key"><span class="editlinktip hasTip" title="Chat Http Port::Chat Http Port">Chat Http Port</span></td>
			<td>
				<input name="http_port" size="50" value=<?php echo $cfg->http_port; ?>>
			</td>
		</tr>
		<tr id="client_location" <?php if($cfg->server == 2){echo 'style="display:none"';}?>>
			<td class="key"><span class="editlinktip hasTip" title="Chat Client Location::e.g. http://host123.123flashchat.com/group_name/">Chat Client Location</span></td>
			<td>
				<input name="client_loc" size="50" value=<?php echo $cfg->client_location; ?>>
			</td>
		</tr>
		<tr id="room_name" <?php if($cfg->server != 2){echo 'style="display:none"';}?>>
			<td class="key">
				<span class="editlinktip hasTip" title="Chat Room Name::If you leave it blank, the room name will be your domain name as default">Chat Room</span>
			</td>
			<td>
				<input name="room" value=<?php echo $cfg->room; ?>>
			</td>
		</tr>
		<tr id="chat_status">
			<td class="key">
				<span class="editlinktip hasTip" title="Show Chat Status::Display the statistics of Total rooms, Total connections and Login users">Show Chat Status</span>
			</td>
			<td>
				<input type="radio" name="chat_status" id="c_status_0" value="1"  onclick="onclick_chat_status(1)" <?php if($cfg->chat_status == 1){echo 'checked="checked"';} ?>>Yes </input>
				<input type="radio" name="chat_status" id="c_status_1" value="0" onclick="onclick_chat_status(0)" <?php if($cfg->chat_status == 0){echo 'checked="checked"';} ?>>No</input>
			</td>
		</tr>
		<tr id="room_list" <?php if($cfg->chat_status == 0 || $cfg->server == 2){echo 'style="display: none"';} ?>>
			<td class="key">
				<span class="editlinktip hasTip" title="Show Room List::Whether you want show chat room list in chat status mod?">Show Room List</span>
			</td>
			<td>
				<input type="radio" name="room_list" value="1" <?php if($cfg->room_list == 1){ echo 'checked="checked"';} ?>>Yes </input>
				<input type="radio" name="room_list" value="0" <?php if($cfg->room_list == 0){ echo 'checked="checked"';} ?>>No</input>
			</td>
		</tr>
		<tr id="user_list" <?php if($cfg->chat_status == 0){echo 'style="display: none"';} ?>>
			<td class="key">
				<span class="editlinktip hasTip" title="Show User List::Whether you want show online user list in chat status mod?">Show User List</span>
			</td>
			<td>
				<input type="radio" name="user_list" value="1" <?php if($cfg->user_list == 1){ echo 'checked="checked"';} ?>>Yes </input>
				<input type="radio" name="user_list" value="0" <?php if($cfg->user_list == 0){ echo 'checked="checked"';} ?>>No</input>
			</td>
		</tr>
		</table>
	<input type="hidden" name="server_local" id="server_local" value=<?php echo $this->valid; ?> />
	</fieldset>
</div>

<div class="col200" >
	<fieldset class="adminform" >
	  <legend>Advanced Settings</legend>
	  <table class="admintable" cellspacing="1">
		<tr id="client_mode" <?php if($cfg->server == 2){echo 'style="display:none"';}?>>
			<td  class="key"><span class="editlinktip hasTip" title="Chat Client Mode::Choose a chat client according to your need">Chat Client Mode</span></td>
			<td>
				 <input type="radio" name="client" id="c_mode_0" value="0" onclick="onclick_client_mode(0)" <?php if($cfg->client == 0){ echo 'checked="checked"';} ?>>Standard Chat
			<br/><input type="radio" name="client" id="c_mode_1" value="1" onclick="onclick_client_mode(1)" <?php if($cfg->client == 1){ echo 'checked="checked"';} ?>>Html Chat
			<br/><input type="radio" name="client" id="c_mode_2" value="2" onclick="onclick_client_mode(2)" <?php if($cfg->client == 2){ echo 'checked="checked"';} ?>>Avatar Chat
			</td>
		</tr>
		<tr id='present_mode' <?php if ($sef_suffix == 1){echo 'style="display:none"';}?>>
			<td class="key">
				<span class="editlinktip hasTip" title="Present Mode::You can set the chat client presents in embedded mode or pop-up mode.">Present Mode</span>
			</td>
			<td>
				<input type="radio" name="present_mode" id="p_mode_0" value="0" onclick="onclick_present_mode(0)" <?php if($cfg->present_mode == 0){ echo 'checked="checked"';} ?>>Embedded </input>
				<input type="radio" name="present_mode" id="p_mode_1" value="1" onclick="onclick_present_mode(1)" <?php if($cfg->present_mode == 1){ echo 'checked="checked"';} ?>>Pop-up</input>
			</td>
		</tr>
		<tr id='client_size'>
			<td class="key">
				<span class="editlinktip hasTip" title="">Chat Client Size:</span>
			</td>
			<td>
				<div>
					<input type="radio" name="full_screen" id="c_size_0" value="0" <?php if($cfg->full_screen == 0 || $sef_suffix == 1){echo 'checked="checked"';} ?>>Width:<input name="client_width" value=<?php echo $cfg->client_width; ?>>
					Height:<input name="client_height" value=<?php echo $cfg->client_height; ?>>
				</div>
				<div id="f_screen"  <?php if ($cfg->server == 2 || $cfg->present_mode == 0 || $sef_suffix == 1) {echo 'style="display:none"';} ?> >
					<input type="radio" name="full_screen" id="c_size_1" value="1" <?php if($cfg->full_screen == 1 && $cfg->server != 2 && $sef_suffix == 0) {echo 'checked="checked"';} ?>>Full Screen
				</div>
			</td>
		</tr>
		<tr>
			<td class="key"><span class="editlinktip hasTip" title="Chat Client Language::Chat Client Language">Chat Client Language</span></td>
			<td>
				<select name="client_lang">
					<option value="*" <?php if($cfg->client_lang == "*"){ echo 'selected';} ?>>Auto detect</option>
					<option value="en" <?php if($cfg->client_lang == "en"){ echo 'selected';} ?>>English</option>
					<option value="zh-CN" <?php if($cfg->client_lang == "zh-CN"){ echo 'selected';} ?>>GB Chinese</option>
					<option value="zh-TW" <?php if($cfg->client_lang == "zh-TW"){ echo 'selected';} ?>>Big5 Chinese</option>
					<option value="fr" <?php if($cfg->client_lang == "fr"){ echo 'selected';} ?>>French</option>
					<option value="it" <?php if($cfg->client_lang == "it"){ echo 'selected';} ?>>Italian</option>
					<option value="de" <?php if($cfg->client_lang == "de"){ echo 'selected';} ?>>German</option>
					<option value="nl" <?php if($cfg->client_lang == "nl"){ echo 'selected';} ?>>Dutch</option>
					<option value="hu" <?php if($cfg->client_lang == "hu"){ echo 'selected';} ?>>Hungarian</option>
					<option value="es" <?php if($cfg->client_lang == "es"){ echo 'selected';} ?>>Spanish</option>
					<option value="hr" <?php if($cfg->client_lang == "hr"){ echo 'selected';} ?>>Croatian</option>
					<option value="tr" <?php if($cfg->client_lang == "tr"){ echo 'selected';} ?>>Turkish</option>
					<option value="ar" <?php if($cfg->client_lang == "ar"){ echo 'selected';} ?>>Arabic</option>
					<option value="pt" <?php if($cfg->client_lang == "pt"){ echo 'selected';} ?>>Portuguese</option>
					<option value="ru" <?php if($cfg->client_lang == "ru"){ echo 'selected';} ?>>Russian</option>
					<option value="ko" <?php if($cfg->client_lang == "ko"){ echo 'selected';} ?>>Korean</option>
					<option value="serbian" <?php if($cfg->client_lang == "serbian"){ echo 'selected';} ?>>Serbian</option>
					<option value="no" <?php if($cfg->client_lang == "no"){ echo 'selected';} ?>>Norwegian</option>
					<option value="ja" <?php if($cfg->client_lang == "ja"){ echo 'selected';} ?>>Japanese</option>
				</select>
			</td>
		</tr>
		<tr id="skin" <?php if($cfg->client){echo 'style="display:none"';}?>>
			<td class="key"><span class="editlinktip hasTip" title="Chat Client Skin::Chat Client Skin">Chat Client Skin</span></td>
			<td>
				<select name="client_skin">
					<option value="default" <?php if($cfg->client_skin == "default"){ echo 'selected';} ?>>Default</option>
					<option value="green" <?php if($cfg->client_skin == "green"){ echo 'selected';} ?>>Green</option>
					<option value="orange" <?php if($cfg->client_skin == "orange"){ echo 'selected';} ?>>Orange</option>
					<option value="red" <?php if($cfg->client_skin == "red"){ echo 'selected';} ?>>Red</option>
					<option value="black" <?php if($cfg->client_skin == "black"){ echo 'selected';} ?>>Black</option>
					<option value="beige" <?php if($cfg->client_skin == "beige"){ echo 'selected';} ?>>Beige</option>
					<option value="standard" <?php if($cfg->client_skin == "standard"){ echo 'selected';} ?>>Standard</option>
					<option value="clean" <?php if($cfg->client_skin == "clean"){ echo 'selected';} ?>>Clean</option>
					<option value="artistic" <?php if($cfg->client_skin == "artistic"){ echo 'selected';} ?>>Artistic</option>
				</select>
			</td>
		</tr>
	  </table>
	</fieldset>	
</div>


<div class="clr"></div>

<input type="hidden" name="option" value="com_chat" />
<input type="hidden" name="id" value="<?php echo $cfg->id; ?>" />
<input type="hidden" name="task" value="save" />
<input type="hidden" name="controller" value="settings" />
</form>
<br />
<!-- Do not remove or change this Copyright Footer! It is part of the Copyright agreement.-->
<div style="border-top-width:1px;border-top-style:solid;border-top-color:#bbbbbb;margin-left:10px;margin-right:10px">123 Flash Chat by <a target="_blank" href="http://www.123flashchat.com">TopCMM</a></div>
<br /><br />


